# Copyright 2023 Luminary Cloud, Inc. All Rights Reserved.
import logging as _logging

from ._client import (
    Client,
    get_default_client,
    set_default_client,
)
from .mesh import (
    get_mesh,
    Mesh,
)
from .project import (
    create_project,
    get_project,
    list_projects,
    Project,
)
from .simulation import (
    get_simulation,
    Simulation,
)
from .vector3 import (
    Vector3,
)

from importlib.metadata import version

try:
    _lc_sdk_version = "v" + version("luminarycloud")
except:
    _lc_sdk_version = "unknown"

# Log SDK version number
_logging.basicConfig(
    format=f"%(asctime)s %(levelname)s python-sdk-{_lc_sdk_version} %(name)s: %(message)s"
)
_logging.getLogger("luminarycloud").debug(f"Imported Luminary Cloud SDK {_lc_sdk_version}")
