"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import luminarycloud._proto.base.base_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _HeatSourceType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _HeatSourceTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_HeatSourceType.ValueType], builtins.type):  # noqa: F821
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    INVALID_HEAT_SOURCE_TYPE: _HeatSourceType.ValueType  # 0
    HEAT_SOURCE_TYPE_POWER: _HeatSourceType.ValueType  # 1
    """In Watts."""
    HEAT_SOURCE_TYPE_POWER_PER_UNIT_OF_VOLUME: _HeatSourceType.ValueType  # 2
    """In Watts/m^3."""

class HeatSourceType(_HeatSourceType, metaclass=_HeatSourceTypeEnumTypeWrapper):
    """Heat sources specification."""

INVALID_HEAT_SOURCE_TYPE: HeatSourceType.ValueType  # 0
HEAT_SOURCE_TYPE_POWER: HeatSourceType.ValueType  # 1
"""In Watts."""
HEAT_SOURCE_TYPE_POWER_PER_UNIT_OF_VOLUME: HeatSourceType.ValueType  # 2
"""In Watts/m^3."""
global___HeatSourceType = HeatSourceType

class Experimental(google.protobuf.message.Message):
    """Message used to store experimental features that are not ready to be used in
    production.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DATA_FIELD_NUMBER: builtins.int
    @property
    def data(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ExperimentalFeatures]:
        """Dummy repeated field used to avoid the backend filling in defaults that we
        don't want to expose in production yet. Since the default value of a
        repeated field is an empty repeated field, this field should never be
        populated in the db-stored fvm param protos.
        """
    def __init__(
        self,
        *,
        data: collections.abc.Iterable[global___ExperimentalFeatures] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["data", b"data"]) -> None: ...

global___Experimental = Experimental

class ExperimentalFeatures(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    HEAT_SOURCES_FIELD_NUMBER: builtins.int
    @property
    def heat_sources(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___HeatSources]:
        """Heat sources. Used in the heat transfer solver."""
    def __init__(
        self,
        *,
        heat_sources: collections.abc.Iterable[global___HeatSources] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["heat_sources", b"heat_sources"]) -> None: ...

global___ExperimentalFeatures = ExperimentalFeatures

class HeatSources(google.protobuf.message.Message):
    """Heat sources message used in the heat transfer solver."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ZONE_IDS_FIELD_NUMBER: builtins.int
    HEAT_SOURCE_POWER_FIELD_NUMBER: builtins.int
    HEAT_SOURCE_POWER_PER_UNIT_VOLUME_FIELD_NUMBER: builtins.int
    HEAT_SOURCE_TYPE_FIELD_NUMBER: builtins.int
    @property
    def zone_ids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.int]:
        """Zone ids that this source applies to."""
    @property
    def heat_source_power(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Heat source in watts."""
    @property
    def heat_source_power_per_unit_volume(self) -> luminarycloud._proto.base.base_pb2.AdFloatType:
        """Heat source in watts / m^3."""
    heat_source_type: global___HeatSourceType.ValueType
    """Heat source specification type. Used to chose between the heat_source_power
    and heat_source_power_per_unit_volume values.
    """
    def __init__(
        self,
        *,
        zone_ids: collections.abc.Iterable[builtins.int] | None = ...,
        heat_source_power: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        heat_source_power_per_unit_volume: luminarycloud._proto.base.base_pb2.AdFloatType | None = ...,
        heat_source_type: global___HeatSourceType.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["heat_source_power", b"heat_source_power", "heat_source_power_per_unit_volume", b"heat_source_power_per_unit_volume"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["heat_source_power", b"heat_source_power", "heat_source_power_per_unit_volume", b"heat_source_power_per_unit_volume", "heat_source_type", b"heat_source_type", "zone_ids", b"zone_ids"]) -> None: ...

global___HeatSources = HeatSources
